#include "ScanRootGui.h"

ClassImp(ScanRootGui)
ScanRootGui::ScanRootGui(TDirectory* dir):ScanRoot(dir)
{
  mTools = new PelTools();
  mBar = 0;
}
ScanRootGui::ScanRootGui(bool debug):ScanRoot(debug)
{
  mTools = new PelTools();
  mBar = 0;
}      
ScanRootGui::~ScanRootGui()
{
  delete mTools;
}
void ScanRootGui::help()
{
  openHelp();
}
void ScanRootGui::menu()
{  
  TList *l = gROOT->GetList();
  int id=-1;
  char line[200];
  char command[400];
  int n = l->GetSize();
  for(int i=0;i<n;i++)
  {
    if(l->At(i)==this) { id=i; break;}
  }
  if(id==-1) return;
  sprintf(line,"((ScanRootGui*)gROOT->GetList()->At(%d))",id);
  
  mBar = new TControlBar("vertical", "ScanRoot Menu");
  
  sprintf(command,"%s->openInputGUI();",line);
  mBar->AddButton("Open .FIL",command,"Opens a data file for input");
  sprintf(command,"%s->getIO()->closeInput();",line);
  mBar->AddButton("Close .FIL",command,"Closes the data file for input");
  sprintf(command,"%s->openOutputGUI();",line);
  mBar->AddButton("New output",command,"Creates a new .FIL file for output");
  sprintf(command,"%s->getIO()->closeOutput();",line);
  mBar->AddButton("Close output",command,"Closes the .FILE file for output");
  sprintf(command,"%s->outputSaveModeGUI();",line);
  mBar->AddButton("Output saving mode",command,"Changes the way of saving the parameters");
  mBar->AddSeparator();
  
  sprintf(command,"%s->hacGUI();",line);
  mBar->AddButton("       Load Histograms       ",command,"Loads the histogram library");
  sprintf(command,"%s->saveHistGUI();",line);
  mBar->AddButton("Save Histograms",command,"Saves the histograms to a file");
  sprintf(command,"%s->addHistGUI();",line);
  mBar->AddButton("Add Histograms",command,"Adds histograms from a file");
  mBar->AddSeparator();
  
  sprintf(command,"%s->loadL2GUI();",line);
  mBar->AddButton("Load L2",command,"Loads a Level-2 trigger library");
  sprintf(command,"%s->unloadL2GUI();",line);
  mBar->AddButton("Unload L2",command,"Unloads the Level-2 trigge library");
  mBar->AddSeparator();
  
  sprintf(command,"%s->zeroGUI();",line);
  mBar->AddButton("Zero",command,"Zero histograms");
  sprintf(command,"%s->goGUI();",line);
  mBar->AddButton("GO",command,"Processes events");
  sprintf(command,"%s->setNParGUI();",line);
  mBar->AddButton("Set NPar",command,"Sets the number of parameters");
  mBar->AddSeparator();
  
  sprintf(command,"%s->initGUI();",line);
  mBar->AddButton("Call init",command,"Initializes the histograms and trigger");
  sprintf(command,"%s->finishGUI();",line);
  mBar->AddButton("Call finish",command,"Finishes the histograms and trigger");
  mBar->AddSeparator();
  
  sprintf(command,"%s->pelTools();",line);
  mBar->AddButton("PelTools Menu",command,"PelTools Menu");
  mBar->AddSeparator();
  
  sprintf(command,"%s->debugGUI();",line,line);
  mBar->AddButton("Debug ON/OFF",command,"Turns ON/OFF debug mode");
  mBar->AddSeparator();
  
  sprintf(command,"%s->stat();",line);
  mBar->AddButton("Stat",command,"Print statistics");
  sprintf(command,"%s->help();",line);
  mBar->AddButton("HELP",command,"HELP ScanRoot");
  sprintf(command,"%s->quitGUI();",line);
  mBar->AddButton("QUIT",command,"QUIT ScanRoot");
    
  mBar->Show();
  gROOT->SaveContext();
  
}
void ScanRootGui::openInputGUI()
{  
  TGFileInfo fi;
  new TGFileDialog(gClient->GetRoot(),gClient->GetRoot(),kFDOpen,&fi);
  if(fi.fFilename)
  {
    getIO()->closeInput(); 
    getIO()->openInput(fi.fFilename);
  }
}
void ScanRootGui::openOutputGUI()
{  
  TGFileInfo fi;
  new TGFileDialog(gClient->GetRoot(),gClient->GetRoot(),kFDSave,&fi);
  if(fi.fFilename)
  {
    getIO()->closeOutput(); 
    getIO()->openOutput(fi.fFilename);
  }
}
void ScanRootGui::outputSaveModeGUI()
{  
  if(getIO()) getIO()->saveOnlyNewPar(!getIO()->isSaveOnlyNewPar());
  else return;
  TString msg;
  if(getIO()->isSaveOnlyNewPar())
    msg = " Save only new parameters to output ";
  else
    msg = " Save ALL the parameters to output";    
  TString title="Output saving mode";
  int retCode;
  new TGMsgBox(gClient->GetRoot(),0,title.Data(),msg.Data(),kMBIconExclamation,kMBOk,&retCode);
  
}
void ScanRootGui::hacGUI()
{  
  TGFileInfo fi;
  new TGFileDialog(gClient->GetRoot(),gClient->GetRoot(),kFDOpen,&fi);
  if(fi.fFilename) loadHist(fi.fFilename); 
}
void ScanRootGui::saveHistGUI()
{  
  TGFileInfo fi;
  new TGFileDialog(gClient->GetRoot(),gClient->GetRoot(),kFDSave,&fi);
  if(fi.fFilename) saveHist(fi.fFilename);
}
void ScanRootGui::addHistGUI()
{  
  TGFileInfo fi;
  new TGFileDialog(gClient->GetRoot(),gClient->GetRoot(),kFDOpen,&fi);
  if(fi.fFilename) addHist(fi.fFilename);
}
void ScanRootGui::loadL2GUI()
{  
  TGFileInfo fi;
  new TGFileDialog(gClient->GetRoot(),gClient->GetRoot(),kFDOpen,&fi);
  if(fi.fFilename) loadL2(fi.fFilename);
}
void ScanRootGui::unloadL2GUI()
{  
  unloadL2();
  TString title="Unload L2";
  TString msg = "L2 trigger is unloaded";
  int retCode;
  new TGMsgBox(gClient->GetRoot(),0,title.Data(),msg.Data(),kMBIconExclamation,kMBOk,&retCode);
}
void ScanRootGui::zeroGUI()
{  
  char *title = " Zero Histogram";
  TString label = "   Enter the name of histogram ( * zeroes ALL)   ";
  TString output = "";
  int stat;
  new TDialog(title,1,&label,&output,&stat);
  if(stat==1)
  {
    if(output.BeginsWith("*")) zero();
    else zero((char*)output.Data());
  }
}
void ScanRootGui::goGUI()
{  
  int N = 0;
  char *title = " Process events from FIL file";
  TString label = "   Enter the number of events (blank for full file)   ";
  TString output = " ";
  int stat;
  new TDialog(title,1,&label,&output,&stat);

  if(stat==1)
  {
    N = atoi((char*)output.Data());
    if(N<=0) N=0;
    go(N);
  }
}
void ScanRootGui::setNParGUI()
{  
  int N = 0;
  char *title = " Number of parameters";
  TString label = "   Enter the number of parameters   ";
  char line[20];
  sprintf(line,"%d",getNPar());
  TString output = line;
  int stat;
  new TDialog(title,1,&label,&output,&stat);
  if(stat==1) setNPar(atoi((char*)output.Data()));
}
void ScanRootGui::quitGUI()
{  
  if(!yesno("Quit Program","Quit SPM-Root acquisition system?")) return;
  gROOT->ProcessLine(".q");
  //TString title="Quit Program";
  //TString msg="Quit ScanRoot?";
  //int retCode;
  //new TGMsgBox(gClient->GetRoot(),0,title.Data(),msg.Data(),kMBIconQuestion,kMBYes+kMBNo,&retCode);
  //if(retCode==kMBYes) gROOT->ProcessLine(".q");
}
void ScanRootGui::debugGUI()
{  
  debug(!getDebug());
  TString msg;
  if(getDebug())
    msg = " Debug Mode is ON";
  else
    msg = " Debug Mode is OFF";    
  TString title="Debug Mode";
  int retCode;
  new TGMsgBox(gClient->GetRoot(),0,title.Data(),msg.Data(),kMBIconExclamation,kMBOk,&retCode);
}
void ScanRootGui::initGUI()
{  
  init();
  TString title="Call init()";
  TString msg = "init() method was called";
  int retCode;
  new TGMsgBox(gClient->GetRoot(),0,title.Data(),msg.Data(),kMBIconExclamation,kMBOk,&retCode);
}
void ScanRootGui::finishGUI()
{  
  finish();
  TString title="Call finish()";
  TString msg = "finish() method was called";
  int retCode;
  new TGMsgBox(gClient->GetRoot(),0,title.Data(),msg.Data(),kMBIconExclamation,kMBOk,&retCode);
}






