/*
 *    camtest.c   << Teste para o Device Driver for A151A Turbo- 27 Jan. 2000
 *                       Author   : R.V. Ribas
 */

#include <errno.h> 
#include <fcntl.h>
#include <stdio.h> 
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <time.h>

#define CCRESET      16
#define CCREAD16     17
#define CCREAD24     18
#define CCREADV16    19
#define CCWRITE16    20
#define CCWRITE24    21
#define CCDMAI16     22
#define CCWAITLAM    23
#define CCREADEVNT   24
#define NAFGEN(n,a,f) (((f << 0x05) | n) | (a << 0x0A))

void  cami16(int, int, int, int *, int *, int *);
void  cami24(int, int, int, int *, int *, int *);
void  camo16(int, int, int, int *, int *, int *);
void  camo24(int, int, int, int *, int *, int *);
int mcami16(int, int, int, short *, int, int *, int *);
int evread16(unsigned int *, unsigned int *, int );
int cc_handle;

main(){

  int N = 10, A = 1, F = 0, D = 0;
  int Q=0,X=0,ierr,arg,i,n,j,k;
  int size,cmd;
  time_t  tod;
  char *evo_name;
  unsigned short int DV[4096];
  FILE *fd; 
  int ni;
  unsigned int xx1,xx2,xx3,xx4;
  char st1[16],st2[16];
  unsigned int instr[1024];

  cc_handle = open ("/dev/pcicc320", O_RDWR);
  if (cc_handle == -1){
      printf(" Erro abrindo Crate PC16t \n");
     exit (-1) ;
  } 

  while (N!=0){
    printf("\n NAF: ");
    scanf("%d %d %d",&N,&A,&F);
    if(N>0){
      if(F>15){
        printf("Data: ");
        scanf("%d",&D);
        camo24(N,A,F,&D,&Q,&X); 
        printf("Q,X %d %d \n",Q,X);
      }
      else{
        cami24(N,A,F,&D,&Q,&X); 
        printf("\n Q,X,Data: %d %d %d %x \n",Q,X,D,D);
      }
    }
    else if (N==0){
      exit(1);
    }
    else {
     N=-N;
     arg=(N|(A<<8));
     ierr = ioctl(cc_handle, CCRESET, (unsigned long) arg);
    }
  }
  close (cc_handle);
}

void cami16(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCREAD16, (unsigned long) arg);
  QX = read (cc_handle, D, 2);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

void cami24(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCREAD24, (unsigned long) arg);
  QX = read (cc_handle, D, 4);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

void camo16(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCWRITE16, (unsigned long) arg);
  arg=*D;
  QX = write (cc_handle,(char *) D, 2);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

void camo24(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCWRITE24, (unsigned long) arg);
  arg=*D;
  QX = write (cc_handle,(char *) D, 4);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

int mcami16(int N, int A, int F, short *Dvec, int size,int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd,n;
  
  arg  = NAFGEN(N,A,F)|0x8000;
  
/*  ierr = ioctl (cc_handle, CCREADV16, (unsigned long) arg);*/
  ierr = ioctl (cc_handle, CCREADEVNT, (unsigned long) arg);
  QX = read (cc_handle, (char *)Dvec, size);
  if (QX==-1)return QX;
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>>1;
  return (QX>>2);
}
int evread16(unsigned int *Dvec, unsigned int *Instr, int size)
{
  int arg, nev;
  int ierr,cmd,n;
  unsigned int buff[1024];
  
  arg=0;
  for(n=0;n<size;n++)buff[n]=Instr[n];
  ierr = ioctl (cc_handle, CCREADEVNT, (unsigned long) arg);
  nev = read (cc_handle, (char *)buff, (size<<2));
  printf(" size, nev %d %d \n",size,nev);
  for(n=0;n<nev;n++)Dvec[n]=buff[n];
  return nev;
}

